urls.py
from django.contrib import admin
from django.urls import path
from _.views import *

urlpatterns = [
    path('admin/', admin.site.urls),
    path('sites/', SiteList.as_view()),
    path('sites/<pk>/', SiteDetails.as_view(), name='sites'),
    path('hazards/', HazardList.as_view()),
    path('hazards/new/', add_hazard_by_widget),
    path('hazards/add/', add_hazard_by_coords),
    path('hazards/<pk>/', HazardDetails.as_view(), name='hazards'),
]

_/models.py
import json
from os import path
from django.db import models
from django.conf import settings
from django.urls import reverse
from django.contrib.gis import forms
from django.contrib.gis.db import models as geo_models
from django.contrib.gis.geos import Polygon


# Create your models here


class Site(models.Model):
    title = models.CharField(max_length=150)
    polygon = geo_models.PolygonField()

    def __str__(self):
        return f'{self.title}'

    def get_absolute_url(self):
        return reverse('sites', kwargs={'pk': self.pk})


def populate_sites():
    with open('sites.json') as json_file:
        data = json.load(json_file)

    for site in data:
        # print(site['title'])
        # print(len(site['points']))
        p_list = [tuple(p) for p in site['points']]
        points = tuple(p_list)
        p = Polygon(points)
        site_obj = {'title': site['title'], 'polygon': p}
        # print(poly)
        s = Site(**site_obj)
        s.save()
    print(f'{len(data)} sites imported')


class Hazard(models.Model):
    title = models.CharField(max_length=150)
    point = geo_models.PointField(srid=4326, null=True)
    created_at = models.DateTimeField(auto_now_add=True)
    sites = models.ManyToManyField(to=Site, related_name='contains')

    def __str__(self):
        return f'{self.title}'

    def get_absolute_url(self):
        return reverse('hazards', kwargs={'pk': self.pk})

    def save(self, *args, **kwargs):

        super(Hazard, self).save(*args, **kwargs)
        if self.pk:
            aff_sites = self.detect_sites()
            # print(aff_sites.count())
            self.sites.set(aff_sites)

    def detect_sites(self):
        hit_site_ids = []
        for s in Site.objects.all():
            if self.point.intersects(s.polygon):
                hit_site_ids.append(s.pk)
                print(s.pk, s, 'is hit')
        sites = Site.objects.filter(pk__in=hit_site_ids)

        print(f'Hazard {self} affects {sites.count()} site(s)')
        return sites

_/forms.py
from django import forms
from django.contrib.gis import forms as geo_forms
from .models import Hazard

DEF_POINT_ATTRS = {'map_width': 500, 'map_height': 500, 'default_lat': 32, 'default_lon': 35}


class HazardForm(forms.Form):

    class Meta:
        title = forms.CharField(max_length=150)
        # point = geo_forms.PointField(widget=forms.OSMWidget(attrs=DEF_POINT_ATTRS))


class HazardModelForm(forms.ModelForm):

    title = forms.CharField(max_length=150)
    # point = geo_forms.PointField(widget=forms.OSMWidget(attrs=DEF_POINT_ATTRS))

    class Meta:
        model = Hazard
        fields = ['title', 'point']
        widgets = {
            'point': geo_forms.OSMWidget(attrs=DEF_POINT_ATTRS)
        }


class HazardCoordForm(forms.Form):
    title = forms.CharField(max_length=150)
    h_lat = forms.FloatField(max_value=180.0, min_value=-180.0)
    h_lng = forms.FloatField(max_value=180.0, min_value=-180.0)

_/views.py
from django.contrib.gis import forms
from django.http import HttpResponse
from django.shortcuts import render
from django.template import RequestContext
from django.views.generic import ListView, DetailView
from .models import Hazard, Site
from .forms import HazardForm, HazardModelForm, HazardCoordForm


# Create your views here.


class SiteList(ListView):
    model = Site


class SiteDetails(DetailView):
    model = Site


class HazardList(ListView):
    model = Hazard


class HazardDetails(DetailView):
    model = Hazard


def add_hazard_by_coords(request):
    print(request)
    if request.method == 'POST':
        form = HazardCoordForm(request.POST)
        if form.is_valid():
            cleaned = form.cleaned_data
            print('cleaned: ', cleaned)
            h = Hazard(cleaned.get(0))
            print('hazard: ', h)
            h.save()
        return HazardList.as_view()

    form_class = HazardCoordForm()
    return render(request, 'add_hazard.html', {
        'form': form_class,
        'widget': forms.OSMWidget({'map_width': 500, 'map_height': 500})
    })


def add_hazard_by_widget(request):
    print(request)
    if request.method == 'POST':
        form = HazardForm(request.POST)
        if form.is_valid():
            data = form.cleaned_data
            print('data: ', data)
            h = Hazard(data.get(0))
            print('hazard: ', h)
            h.save()
        return HazardList.as_view()

    form_class = HazardModelForm()
    return render(request, 'new_hazard.html', {
        'form': form_class,
        'widget': forms.OSMWidget({'default_lon': 35, 'default_lat': 32, 'map_width': 500, 'map_height': 500})
    })

templates/_/hazard_detail.html
{% load static %}
{#<!DOCTYPE html>#}
{#<html lang="en">#}
{#<head>#}
{#    <meta charset="UTF-8">#}
{#    <title>Hazard "{{ object }}" [#{{ object.pk }}] (affects {{ object.sites.count }} sites)</title>#}
{#    <link href="{% static 'bootstrap.min.css' %}" rel="stylesheet" type="text/css">#}
{#    <link href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css" integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A==" crossorigin="" rel="stylesheet" type="text/css" />#}
{#</head>#}
{#<body class="text-left container-fluid" dir="rtl">#}
<style rel="stylesheet" type="text/css">
    .site {color: #000060; font-weight: 700;}
    .hazard {color: #600000; font-weight: 700;}
    a:hover {text-decoration: none;}
</style>
<div class="hazard alert alert-danger m-2 w-75 text-right">
    {{ object.pk }}. {{ object.title }} [@{{ object.created_at }}]
</div>
{% if object.sites.count %}
    <h5 class="w-100 text-center">Sites</h5>
    {% for s in object.sites.all %}
        <div class="alert alert-dark m-2 w-100 text-right">
            <a class="site" href="/sites/#/{{ s.pk }}">
                {{ forloop.counter }}. {{ s }} [#{{ s.pk }}]
            </a>
        </div>
    {% endfor %}
{% endif %}
{#<script src="{% static 'jquery-3.6.0.min.js' %}" type="text/javascript"></script>#}
{#<script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js" integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA==" crossorigin=""></script>#}
{#<script src="{% static 'bootstrap.min.js' %}" type="text/javascript"></script>#}
{#</body>#}
{#</html>#}

templates/_/hazard_list.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Hazards ({{ hazard_list.count }} total)</title>
    <link href="{% static 'bootstrap.min.css' %}" rel="stylesheet" type="text/css">
    <link href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css"
          integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A=="
          crossorigin="" rel="stylesheet" type="text/css"/>
    <style rel="stylesheet" type="text/css">
        .close {float: left !important;}
        .i-circle-add {background: #006000; color: #fff; margin: 0 0 0 10px; border-radius: 50%; padding: 0 5px; font-size: large;}
        .i-circle-haz {background: #600000; color: #fff; margin: 0 0 0 10px; border-radius: 50%; padding: 0 7px; font-size: large;}
        .hazard {color: #600000;font-weight: 700;}
        a:hover {text-decoration: none;}
    </style>
</head>
<body class="text-left container-fluid" dir="rtl">
<div class="row">
    <div id="hazard_list" class="col-lg">
                <div class="alert alert-warning m-2 w-100 text-right">
                    <a href="/hazards/add/" class="hazard">
                        <span class="i-circle-add">+</span>
                        Add hazard
                    </a>
                </div>
                <div class="alert alert-warning m-2 w-100 text-right">
                    <a href="/hazards/new/" class="hazard">
                        <span class="i-circle-add">+</span>
                        New hazard
                    </a>
                </div>
        {% for h in object_list %}
            <div class="alert alert-warning m-2 w-100 text-right">
                <a data-toggle="collapse" href="#hazard_details" role="button" aria-controls="hazard_details"
                   class="hazard view" data-abs-url="{{ h.get_absolute_url }}">
                    <span class="i-circle-haz">!</span>
                    {{ forloop.counter }}.{{ h }}
                </a>
            </div>
        {% endfor %}
    </div>
    <div id="hazard_details" class="col-lg-6 collapse">
        <div class="alert alert-dark m-2 w-100 text-right">
            <button class="close">&times;</button>
            <div id="hazard_content" class="mb-3 pt-2"></div>
        </div>
    </div>
</div>

<script src="{% static 'jquery-3.6.0.min.js' %}" type="text/javascript"></script>
<script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js" type="text/javascript"
        integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA=="
        crossorigin=""></script>
<script src="{% static 'bootstrap.min.js' %}" type="text/javascript"></script>
<script type="text/javascript">
    $(document).ready(function (){
       {#let site = location.hash;#}
       let idx = Number(location.hash.split('/').pop());
       if (idx > 0 && idx <= $('#hazard_list > .alert > .hazard').length) {
           $($('#hazard_list > .alert > .hazard')[idx]).trigger('click');
       }

       {#// console.log(site);#}
    });
    let show_hazard = function (e) {
        // console.debug('show_hazard');
        let hazard = $(e.target);
        e.stopPropagation();
        e.preventDefault();
        {#// console.log(hazard);#}
        // console.log(hazard.data('abs-url'));
        $.get(hazard.data('abs-url')).done(function (html) {
            $('#hazard_content').html(html);
            $('#hazard_details').show();
            //// console.debug(html);
            // return false;
        });
    };

    let show_site = function (e) {
        // console.debug('show_site');
        let site = $(e.target);
        e.stopPropagation();
        e.preventDefault();
        location.href = site.data('abs-url');
            {#$.get(site.data('abs-url')).done(function (html) {#}
            {#    // console.log(html);#}
            {#    $('#hazard_content').html(html);#}
            {#    $('#hazard_details').show();#}
            {#    //// console.debug(html);#}
            {#    // return false;#}
            {# }); #}
    };

    let close_hazard = function () {
        // console.log('close_hazard');
        $('#hazard_content').html('');
        $('#hazard_details').hide();
    };

    $('.close').on('click', close_hazard);
    $('.view').on('click', show_hazard);
    $('.site').on('click', show_site);

</script>
</body>
</html>

templates/_/site_detail.html
{% load static %}
{#<!DOCTYPE html>#}
{#<html lang="en">#}
{#<head>#}
{#    <meta charset="UTF-8">#}
{#    <title>Site "{{ object }}" [#{{ object.pk }}] (has {{ object.contains.count }} hazards)</title>#}
    <link href="{% static 'bootstrap.min.css' %}" rel="stylesheet" type="text/css">
    <link href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css" integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A==" crossorigin="" rel="stylesheet" type="text/css" />
{#</head>#}
{#<body class="text-left container-fluid pt-2" dir="rtl">#}
<style rel="stylesheet" type="text/css">
    .site {color: #000060; font-weight: 700;}
    a:hover {text-decoration: none;}
    .hazard {color: #600000; font-weight: 700;}
</style>
<div class="site alert alert-dark m-2 w-75 text-right">
    {{ object.pk }}. {{ object.title }}
</div>
{% if object.contains.count %}
    <h5 class="w-100 text-center">Hazards</h5>
    {% for h in object.contains.all %}
        <div class="alert alert-dark m-2 w-100 text-right">
            <a class="hazard" href="/hazards/#/{{ h.pk }}">
                {{ forloop.counter }}. {{ h }} [#{{ h.pk }}]
            </a>
        </div>
    {% endfor %}
{% endif %}
<script src="{% static 'jquery-3.6.0.min.js' %}" type="text/javascript"></script>
<script src="{% static 'bootstrap.min.js' %}" type="text/javascript"></script>
<script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js" integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA==" crossorigin=""></script>

<script type="text/javascript">
    $(document).ready( function () {
        polygon = {{ object.polygon.geojson | safe }};
        // console.log('polygon: ', polygon);
        map = L.map('site_map').setView([51.505, -0.09], 13);
        L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(map);
        bounds = L.geoJSON(polygon).addTo(map).getBounds();
        map.fitBounds(bounds);
        window.scrollTo(0,0);
        localStorage.setItem('lastSite', JSON.stringify(map.getCenter()));
        {#debugger;#}
    });
</script>
{#</body>#}
{#</html>#}

templates/_/site_list.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Sites ({{ site_list.count }} total)</title>
    <link href="{% static 'bootstrap.min.css' %}" rel="stylesheet" type="text/css">
    <link href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css"
   integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A=="
   crossorigin="" rel="stylesheet" type="text/css" />
    <style rel="stylesheet" type="text/css">
        .close {float: left !important;}
        .site {color: #000060; font-weight: 700;}
        a:hover {text-decoration: none;}
        .hazard {color: #600000; font-weight: 700;}
        #site_map {height: 90vh;}
    </style>
</head>
<body class="text-left container-fluid" dir="rtl">
<div class="row">
    <div id="site_list" class="col-lg">
        {% for s in object_list %}
            <div class="alert alert-dark m-2 w-100 text-right">
                <a data-toggle="collapse" href="#site_details" role="button" aria-controls="site_details" class="site" data-abs-url="{{ s.get_absolute_url }}">
                    {{ s.pk }}. {{ s }}
                </a>
            </div>
        {% endfor %}
    </div>
    <div id="site_details" class="col-lg-6 collapse">
        <div class="alert alert-dark m-2 w-100 text-right">
            <button class="close">&times;</button>
            <div id="site_content" class="mb-3 pt-2"></div>
            <div id="site_map"></div>
        </div>
    </div>
</div>

<script src="{% static 'jquery-3.6.0.min.js' %}" type="text/javascript"></script>
<script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js" integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA==" crossorigin=""></script>
<script src="{% static 'bootstrap.min.js' %}" type="text/javascript"></script>
<script type="text/javascript">
    let map, polygon, bounds, polypoints, center;
    $(document).ready(function (){
       let idx = Number(location.hash.split('/').pop());
       if (idx > 0 && idx <= $('#site_list > .alert > .site').length) {
           $($('#site_list > .alert > .site')[idx-1]).trigger('click');
       }
    });
    let show_site = function (e) {
        // console.log('show_site');
        if (map) {
            map.off();
            map.remove();
        }
        e.stopPropagation();
        e.preventDefault();
        let url =  $(e.target).data('abs-url');
        // console.log('url: ', url);
        {#// console.log(site);#}
        {#// console.log(site.attr('href'));#}
        $.get(url).done(function (html) {
            $('#site_content').html(html);
            $('#site_details').show();
            //// console.debug(html);
            // return false;
        });
    };

    let close_site = function () {
        // console.log('close_site');
        $('#content').html('');
        $('#site_map').html('');
        map.off();
        map.remove();
        map = null;
        $('#site_details').hide();
    };

    $('.site').on('click', show_site);
    $('.close').on('click', close_site);

</script>
</body>
</html>

templates/add_hazard.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Add new hazard</title>
    <link href="{% static 'bootstrap.min.css' %}" rel="stylesheet" type="text/css">
    <link href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css" integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A==" crossorigin="" rel="stylesheet" type="text/css" />
</head>
<body class="text-left container-fluid" dir="rtl">
<style rel="stylesheet">
    .site {color: #000060; font-weight: 700;}
    .hazard {color: #600000; font-weight: 700;}
    a:hover {text-decoration: none;}
</style>
<div class="hazard alert alert-danger m-2 w-75 text-left" dir="ltr">
    <form action="/hazards/add/" method="POST">
        {% csrf_token %}
        <label for="id_title">Title:</label>
        <br>
        {{ form.title }}
        <br>
        <label for="h_lat">Lat:</label>
        <br>
        {{ form.h_lat }}
        <br>
        <label for="h_lat">Lng:</label>
        <br>
        {{ form.h_lng }}
        <br>
        <br>
        <input type="submit" value="Add Hazard" />
        <div id="hazard_map"></div>
    </form>
</div>

<script src="{% static 'jquery-3.6.0.min.js' %}" type="text/javascript"></script>
<script src="{% static 'bootstrap.min.js' %}" type="text/javascript"></script>
<script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js" integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA==" crossorigin=""></script>

<script type="text/javascript">
    $(document).ready( function () {
        let h_map = L.map('hazard_map').setView([51.505, -0.09], 13);
        L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(h_map);
        let lastPos = localStorage.getItem('lastSite');

    });
</script>
</body>
</html>

templates/new_hazard.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>New hazard</title>
    {{ form.media }}
    <link href="{% static 'bootstrap.min.css' %}" rel="stylesheet" type="text/css">
    <link href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css" integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A==" crossorigin="" rel="stylesheet" type="text/css" />
</head>
<body class="text-left container-fluid" dir="rtl">
<link href="{% static 'ol.css' %}" rel="stylesheet" type="text/css">
<script src="{% static 'ol.js' %}" type="text/javascript"></script>
<style rel="stylesheet">
    .site {color: #000060; font-weight: 700;}
    .hazard {color: #600000; font-weight: 700;}
    a:hover {text-decoration: none;}
</style>
<div class="hazard alert alert-danger m-2 w-75 text-right">
    <form action="/hazards/new/" method="POST">
        {% csrf_token %}
        {{ form }}
        <input type="submit" value="Add Hazard" />
    </form>
</div>
{#<script src="{% static 'jquery-3.6.0.min.js' %}" type="text/javascript"></script>#}
{#<script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js" integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA==" crossorigin=""></script>#}
{#<script src="{% static 'bootstrap.min.js' %}" type="text/javascript"></script>#}
{#</body>#}
{#</html>#}